<?php
/*
 * Comingsoon Syntax Plugin.
 *
 * @license  Apache 2 (http://www.apache.org/licenses/LICENSE-2.0)
 * @author   Kazuyuki Matsuda <kazm@shorindo.com>
 */

if (!defined('DOKU_INC')) die();
if (!defined('DOKU_LF')) define('DOKU_LF', "\n");
if (!defined('DOKU_TAB')) define('DOKU_TAB', "\t");
if (!defined('DOKU_PLUGIN')) define('DOKU_PLUGIN',DOKU_INC.'lib/plugins/');
require_once(DOKU_PLUGIN.'syntax.php');

class syntax_plugin_comingsoon extends DokuWiki_Syntax_Plugin {

	function getInfo() {
        return confToHash(dirname(__FILE__).'/plugin.info.txt');
	}

	function getType() { return 'container'; }

	function getSort() { return 200; }

	function getPType() { return 'block';}

	function connectTo($mode) {
		$this->Lexer->addSpecialPattern('\{\{comingsoon\}\}', $mode, 'plugin_comingsoon');
	}

	function handle($match, $state, $pos, &$handler) {
		return array($state);
    }

	function render($mode, &$renderer, $data) {
		if($mode == 'xhtml'){
			list($state, $params) = $data;
            $this->setmeta(getID());
        }
    }

    /**
     * Write pageid to meta file.
     */
    function setmeta($id) {
        $fname = metaFN('', '_commingsoon.txt');
        io_lock($fname);
        if (file_exists($fname)) {
            $meta = unserialize(file_get_contents($fname));
            $meta[$id] = 1;
        } else {
            $meta = array($id => 1);
        }
        $fh = @fopen($fname, "wb");
        if (!$fh) {
            io_unlock($fname);
            return false;
        }
        fwrite($fh, serialize($meta));
        fclose($fh);
        io_unlock($fname);
        return true;
    }

    /**
     * Read pageid from meta file.
     */
    function getmeta($id) {
        $fname = metaFN('', "_commingsoon.txt");
        if (!@file_exists($fname)) {
            return 0;
        }
        return unserialize(file_get_contents($fname));
    }
}
